﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GridLoadFromXML
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void ultraGrid2_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.DataSource = CreateData();
            this.ultraGrid2.DataSource = CreateData();
        }

        ObservableCollection<Data> CreateData()
        {
            var collection = new ObservableCollection<Data>
            {
                new Data("Infragistics", "http://www.infragistics.com/",4),
                new Data("No Website", "Invalid URL", 7),
                new Data("MSDN", "http://msdn.microsoft.com/en-us/library/ms123401.aspx", 6),
                new Data("No Website", "Invalid URL", 3),
                new Data("Google", "http://www.google.com", 4),
                new Data("No Website", "Invalid URL", 2),
            };
            return collection;
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            FileStream fs = null;
            try
            {
                // Open a new file to save the layout to.
                fs = new System.IO.FileStream("D:\\XMLDocument.xml", System.IO.FileMode.Create, System.IO.FileAccess.Write, System.IO.FileShare.None);
            }
            catch (Exception exc)
            {
                MessageBox.Show(this, "D:\\XMLDocument.xml" + " file not found. " + exc.Message, "Unable to open file", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            // Save the layout to the file in xml format.
            this.ultraGrid1.DisplayLayout.SaveAsXml(fs, PropertyCategories.All);

            fs.Close();
        }

        private void ultraButton2_Click(object sender, EventArgs e)
        {
            System.IO.FileStream fs = null;

            try
            {
                // Open the file where we saved the layout to in xml format.
                fs = new System.IO.FileStream("D:\\XMLDocument.xml", System.IO.FileMode.Open, System.IO.FileAccess.Read, System.IO.FileShare.Read);
            }
            catch (Exception exc)
            {

                MessageBox.Show(this, "D:\\XMLDocument.xml" + " file not found. " + exc.Message, "Unable to open file", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            // Load the layout from the input stream by calling LoadFromXml method. It is very important 
            // that you reset the Position of the file stream to where the layout data begins in case the 
            // file stream has been read from previously.
            this.ultraGrid2.DisplayLayout.LoadFromXml(fs, PropertyCategories.All);

            // Close the file.
            fs.Close();
        }

        private void ultraButton3_Click(object sender, EventArgs e)
        {
            this.ultraGrid2.DisplayLayout.Bands[0].Columns.Add("CalculatedColumn", "Calculated Value");

        }
    }
    class Data
    {
        public string Name { get; set; }
        public string WebSite { get; set; }

        public int IntColumn { get; set; }

        public Data(string name, string website, int intCol)
        {
            Name = name;
            WebSite = website;
            IntColumn = intCol;
        }
    }

}
